module sysreg(
    input                       i_rst_n,
    input                       i_clk,
    input      [15:0]           uart_addr,
    input                       uart_wren,
    output reg                  uart_wdat_rdy,
    input      [31:0]           uart_wdata,
    input                       uart_rden,
    output reg                  uart_rdat_vld,
    output reg [31:0]           uart_rdata,
	
    output reg [31:0] reg0x0000,output reg [31:0] reg0x0010,output reg [31:0] reg0x0020,output reg [31:0] reg0x0030,
    output reg [31:0] reg0x0001,output reg [31:0] reg0x0011,output reg [31:0] reg0x0021,output reg [31:0] reg0x0031,
    output reg [31:0] reg0x0002,output reg [31:0] reg0x0012,output reg [31:0] reg0x0022,output reg [31:0] reg0x0032,
    output reg [31:0] reg0x0003,output reg [31:0] reg0x0013,output reg [31:0] reg0x0023,output reg [31:0] reg0x0033,

    input [31:0] mon0x0080,input [31:0] mon0x0090,input [31:0] mon0x00A0,input [31:0] mon0x00B0,
    input [31:0] mon0x0081,input [31:0] mon0x0091,input [31:0] mon0x00A1,input [31:0] mon0x00B1,
    input [31:0] mon0x0082,input [31:0] mon0x0092,input [31:0] mon0x00A2,input [31:0] mon0x00B2,
    input [31:0] mon0x0083,input [31:0] mon0x0093,input [31:0] mon0x00A3,input [31:0] mon0x00B3


);

reg     uart_wren_d1;
always @(posedge i_clk or negedge i_rst_n) begin
    if(!i_rst_n) begin
        uart_wren_d1    <=  1'd0;
    end else begin
        uart_wren_d1    <=  uart_wren;
    end
end

always @(posedge i_clk or negedge i_rst_n) begin
    if(!i_rst_n) begin
        uart_wdat_rdy   <=  1'd0;
    end else begin
        uart_wdat_rdy   <=  uart_wren && ~uart_wren_d1;
    end
end

always @(posedge i_clk or negedge i_rst_n) begin
    if(!i_rst_n) begin
        reg0x0000   <=  32'd0;
        reg0x0001   <=  32'd0;
        reg0x0002   <=  32'd0;
        reg0x0003   <=  32'd0;

        reg0x0010   <=  32'd0;
        reg0x0011   <=  32'h0000_00AA;
        reg0x0012   <=  32'h0000_000F;
        reg0x0013   <=  32'd0;

        reg0x0020   <=  32'h0006_666F;
        reg0x0021   <=  32'h0030_0030;
        reg0x0022   <=  32'h0030_0030;
        reg0x0023   <=  32'd0;

        reg0x0030   <=  32'h0000_0001;
        reg0x0031   <=  32'd0;
        reg0x0032   <=  32'd0;
        reg0x0033   <=  32'd0;
    end else if(uart_wren && uart_wdat_rdy) begin
        case(uart_addr[7:0])
            8'h00:  reg0x0000   <=  uart_wdata;
            8'h01:  reg0x0001   <=  uart_wdata;
            8'h02:  reg0x0002   <=  uart_wdata;
            8'h03:  reg0x0003   <=  uart_wdata;

            8'h10:  reg0x0010   <=  uart_wdata;
            8'h11:  reg0x0011   <=  uart_wdata;
            8'h12:  reg0x0012   <=  uart_wdata;
            8'h13:  reg0x0013   <=  uart_wdata;

            8'h20:  reg0x0020   <=  uart_wdata;
            8'h21:  reg0x0021   <=  uart_wdata;
            8'h22:  reg0x0022   <=  uart_wdata;
            8'h23:  reg0x0023   <=  uart_wdata;

            8'h30:  reg0x0030   <=  uart_wdata;
            8'h31:  reg0x0031   <=  uart_wdata;
            8'h32:  reg0x0032   <=  uart_wdata;
            8'h33:  reg0x0033   <=  uart_wdata;
        endcase
    end
end

reg     uart_rden_d1;
always @(posedge i_clk or negedge i_rst_n) begin
    if(!i_rst_n) begin
        uart_rden_d1    <=  1'd0;
    end else begin
        uart_rden_d1    <=  uart_rden;
    end
end

always @(posedge i_clk or negedge i_rst_n) begin
    if(!i_rst_n) begin
        uart_rdat_vld   <=  1'd0;
    end else begin
        uart_rdat_vld   <=  uart_rden && ~uart_rden_d1;
    end
end

always @(posedge i_clk or negedge i_rst_n) begin
    if(!i_rst_n) begin
        uart_rdata  <=  32'd0;
    end else begin
        case(uart_addr[7:0])
            8'h00:  uart_rdata  <=  reg0x0000;
            8'h01:  uart_rdata  <=  reg0x0001;
            8'h02:  uart_rdata  <=  reg0x0002;
            8'h03:  uart_rdata  <=  reg0x0003;

            8'h10:  uart_rdata  <=  reg0x0010;
            8'h11:  uart_rdata  <=  reg0x0011;
            8'h12:  uart_rdata  <=  reg0x0012;
            8'h13:  uart_rdata  <=  reg0x0013;

            8'h20:  uart_rdata  <=  reg0x0020;
            8'h21:  uart_rdata  <=  reg0x0021;
            8'h22:  uart_rdata  <=  reg0x0022;
            8'h23:  uart_rdata  <=  reg0x0023;

            8'h30:  uart_rdata  <=  reg0x0030;
            8'h31:  uart_rdata  <=  reg0x0031;
            8'h32:  uart_rdata  <=  reg0x0032;
            8'h33:  uart_rdata  <=  reg0x0033;

            8'h80:  uart_rdata  <=  mon0x0080;
            8'h81:  uart_rdata  <=  mon0x0081;
            8'h82:  uart_rdata  <=  mon0x0082;
            8'h83:  uart_rdata  <=  mon0x0083;

            8'h90:  uart_rdata  <=  mon0x0090;
            8'h91:  uart_rdata  <=  mon0x0091;
            8'h92:  uart_rdata  <=  mon0x0092;
            8'h93:  uart_rdata  <=  mon0x0093;

            8'hA0:  uart_rdata  <=  mon0x00A0;
            8'hA1:  uart_rdata  <=  mon0x00A1;
            8'hA2:  uart_rdata  <=  mon0x00A2;
            8'hA3:  uart_rdata  <=  mon0x00A3;

            8'hB0:  uart_rdata  <=  mon0x00B0;
            8'hB1:  uart_rdata  <=  mon0x00B1;
            8'hB2:  uart_rdata  <=  mon0x00B2;
            8'hB3:  uart_rdata  <=  mon0x00B3;

            default:uart_rdata  <=  32'd0;	
        endcase
    end
end

endmodule
